// src/plugins/utils.ts
function removeMutableWarning(code) {
  const warning = "is immutable but was modified from within the component";
  const index = code.indexOf(warning);
  if (index === -1) {
    throw new Error(
      "Couldn't find check for mutable in Stencil's code. This may have happened if Stencil updated their source code in src/runtime/proxy-component.ts - this plugin needs to be updated to match new Stencil version"
    );
  }
  const warningStart = code.lastIndexOf("consoleDevWarn", index);
  const warningEnd = code.indexOf(");", warningStart) + ");".length;
  return code.slice(0, warningStart) + code.slice(warningEnd);
}

export {
  removeMutableWarning
};
