import { Plugin } from 'rollup';

/**
 * Plugin that automatically injects Stencil lifecycle methods that call the
 * controller for every component in which controller is used.
 *
 * If component already has a lifecycle event, it will be merged automatically,
 * with controller called before components's lifecycle event.
 */
declare const useComponentsControllers: () => Plugin;

export { useComponentsControllers };
