const path = require("node:path");
const stencilPreset = require("@stencil/core/testing/jest-preset.js");

const packageRoot = path.dirname(require.resolve("@arcgis/components-controllers/jest-preset"));
const jestPreprocessor = path.join(packageRoot, "dist/plugins/jestPreprocessor.cjs");

module.exports = {
  ...stencilPreset,
  transform: {
    "@stencil/core/internal/testing/index.js$": jestPreprocessor,
    "core-adapter/dist/index.cjs$": jestPreprocessor,
    // .ts and .tsx files are scanned for presence of Stencil components.
    "\\.(ts|tsx)$": jestPreprocessor,
    ...stencilPreset.transform,
  },
  // Do not ignore @arcgis/core-adapter - let it be transformed
  transformIgnorePatterns: [
    "node_modules/(?!@arcgis/core-adapter/|@stencil/core/internal/testing)",
    "\\.pnp\\.[^\\/]+$",
  ],
};
